﻿// JRMC Gadget v2.4

// Strings
var DETAILS_TITLE = "Tag Details";
var ADDTOPL_TITLE = "Add To Playlist";

// Images for rating
var IMG_RATE_SELECT = "images/rating_select.png";
var IMG_RATE_NOSELECT = "images/rating_noselect.png";
var IMG_RATE_NONE = "images/rating_none.png";
var IMG_CLEAR_OVER = "images/rating_clear.png";
var IMG_CLEAR_LEAVE = "images/rating_clear2.png";

// Global variables
var gCurrentFile = null;
var gTags = "";
var gPlaylists = null;
var gPLArray = null;

function Init(file, tags, playlists)
{
    gCurrentFile = file;
    gTags = tags;
    gPlaylists = playlists;
}

// Generate the html for the Flyout
function Fill()
{
    try
    {
        if( gCurrentFile == null)
            return false;
        
        // Title plus table of desired tags
        var htmlStr = "<div id=\"DETAILSTITLE\">" + DETAILS_TITLE + "</div><br><div id=\"FIELDSAREA\"><table id=\"FIELDSTABLE\">";
        var tags = gTags.split( ";");
        for( var i=0; i < tags.length; i++)
        {
            if( tags[i] == "Rating")
                htmlStr += "<tr><td class=\"FieldColumn\">" + tags[i] + "</td><td class=\"ValueColumn\">" + GenerateRatingHTML(gCurrentFile.Rating) + "</td></tr>";
            else if( tags[i] == "Playlists")
                htmlStr += "<tr><td class=\"FieldColumn\">" + tags[i] + "</td><td class=\"ValueColumn\">" + GeneratePlaylistsHTML() + "</td></tr>"; 
            else
                htmlStr += "<tr><td class=\"FieldColumn\">" + tags[i] + "</td><td class=\"ValueColumn\">" + gCurrentFile.Get(tags[i], true) + "</td></tr>";
                            
        }
        htmlStr += "</table></div>";
        
        document.body.innerHTML = htmlStr;
    }
    catch(err)
    {
       // document.body.innerHTML = err.Description;
    }
}

// Generate the special html for Ratings selection
function GenerateRatingHTML(rating)
{
    var str = "";
    for( var j=1; j<6; j++)
    {
        var img = j <= rating ? IMG_RATE_NOSELECT : IMG_RATE_NONE;
        str += "<a id='link_" + j + "' href='javascript:void(0);' onClick='ClickRating("+j+");'>"
                + "<img border=0 id='bar_" + j + "' hspace='3' src='"+img+"' "
                + "onMouseOver='src=\"" + IMG_RATE_SELECT + "\"' onMouseOut='src=\""+img+"\"';"
                + "onAction(\"" + j + "\");' \>"
                + "</a>";
    }
    if( rating > 0)
    {
        j = 0;
        str += "<a id='link_" + j + "' href='javascript:void(0);' onClick='ClickRating("+j+");'>"
                + "<img style=\"position: relative; top: -2px\" border=0 id='bar_" + j + "' hspace='3' src='" + IMG_CLEAR_LEAVE + "' "
                + "onMouseOver='src=\""+ IMG_CLEAR_OVER +"\"' onMouseOut='src=\"" + IMG_CLEAR_LEAVE + "\"';"
                + "onAction(\"" + j + "\");' \>"
                + "</a>";
    }
    return str;
}

// Generate the special html for Playlist selection
function GeneratePlaylistsHTML()
{
    var str = "";
    var playlists = gCurrentFile.GetPlaylists();
    for( var j=0; j<playlists.GetNumberPlaylists(); j++)
        str += playlists.GetPlaylist(j).Name + ", ";
         
    str += "<a id='linkaddtopl' href='javascript:void(0);' onClick='ClickShowPlaylists();'>Add to...</a>";
    return str;
}

// Set rating on click
function ClickRating(rating)
{
    try
    {
        if( gCurrentFile == null)
            return;
    
        gCurrentFile.Rating = rating;
        Fill();
    }
    catch( err)
    {
   //     document.body.innerText = err.Description;
    }
}

// Show playlists
function ClickShowPlaylists()
{
    try
    {
        if( gPlaylists == null)
            return false;
            
        // copy to array and sort
        gPLArray = new Array();
        for( var i=0; i < gPlaylists.GetNumberPlaylists(); i++)
            gPLArray[i] = gPlaylists.GetPlaylist( i);
        gPLArray.sort( sortPlaylists);    
        
         
        // write html
        var htmlStr = "<div id=\"DETAILSTITLE\">" + "<a id='closepl' style='color:red' href='javascript:void(0);' onClick='Fill();'><img style=\"width:13px\" border=0 src=\""+ IMG_CLEAR_OVER +"\"/></a>" + ADDTOPL_TITLE + "</div><div id=\"PLAREA\"><br/><ul>";
        var currentpath = "";
        for( var j=0; j < gPLArray.length; j++)
        {
            // only show playlists
            var pl = gPLArray[j];
            if( pl.Get( "Type") != "0")
                continue;
                
            // write path
            if( pl.Path != currentpath)
            {     
                currentpath = pl.Path;
                htmlStr +=  "</ul><div>" + currentpath + "</div><ul>"; 
            }
                
            htmlStr += "<li><a id=\"pl_" + pl.GetID() + "\" class=\"OutPlaylist\" href=\"javascript:void(0);\" onClick=\"ClickAddToPlaylist("+j+");\">" + pl.Name + "</a><br/></li>";
        }
        htmlStr += "</ul></div>";    
        document.body.innerHTML = htmlStr;
        
        // Mark playlists
        MarkInPlaylists();
    }
    catch( err)
    {
     //   document.body.innerText = err.Description;
    }
}

function sortPlaylists(a, b)
{
    if( a.Path < b.Path)
        return -1;
    else if( a.Path > b.Path)
        return 1;
    else
    {
        if( a.Name < b.Name)
            return -1;
         else
            return 1;
    }
}

function ClickAddToPlaylist(index)
{
    try
    {
        if( gCurrentFile == null)
            return;
            
        var pl = gPLArray[index];
        pl.AddFile( gCurrentFile.Filename, -1);
        MarkInPlaylists();
    }
    catch( err)
    {
   //     document.body.innerText = err.Description;
    }
    
   //  Fill();
}

function MarkInPlaylists()
{
    var playlists = gCurrentFile.GetPlaylists();
    for( var j=0; j<playlists.GetNumberPlaylists(); j++)
    {
        var elem = document.getElementById( "pl_" + playlists.GetPlaylist(j).GetID());
        if( elem != null)
            elem.className = "InPlaylist";
    }
       
}
