﻿// JRMC Gadget v2.4

// Images
var THUMB_SIZING = "?width=50&height=50";
var BAR_IMAGES_PATH = "images/";
var gImageFiles      = new Array(
                            System.Gadget.path + "\\images\\background.jpg",
                            System.Gadget.path + "\\logo.png",
                            System.Gadget.path + "\\images\\NoThumb.png");

// State strings
var STATE_STOP = "Stopped";
var STATE_PAUSE = "Paused";
var STATE_PLAY = "Playing";
var PLAY_SEPARATOR = " / ";

// Playing Now expression for display string 
var gPlayNowExp = "If( IsEqual([Media Type],Audio), <i>[Name]<//i> by [Artist], [Name]<br>[Date] )";

// Tags to show in Flyout
var gFlyoutTags = "Name;Artist;Album;Rating;Genre;Date;Duration;Playlists";

// Strings
var ERROR1 = "Not connected";
var ERROR2 = "Click the button on the right of the control bar.";
var CONNECTING = "Connecting...";

// Global variables
var jrmc = null;
var gTimer = null;
var gCurrentPos = -1;
var gState = -1;
var gPlayStr = "";
var gBorder = "";
var gDivider = 0;

// v2.0
var gZone = 0;
var gStartUpCommand = "";

// v2.1
var gHeight = 130;
var gImageDisplay = 0;
var gTimeStr = "-{R}";

// v2.2
var gShowUI = true;
var gAutoConnect = false;

// v2.3
var IMAGE_DISPLAY_SMALL = 0;
var IMAGE_DISPLAY_FULL = 1;
var IMAGE_DISPLAY_SWITCH = 2;
var IMAGE_DISPLAY_SWITCH2 = 3;
var IMAGE_DISPLAY_FULLTEXT = 4;
var IMAGE_DISPLAY_NONE = 5;
var gSwitchImgDisplay = false;
var gCoverWidth = 50;

// v2.4
var gAttempts = 0;
var gLauncher = "MC14.exe";
var REG_INSTALL = "HKLM\\Software\\J. River\\Media Core\\Installations\\";
var gSwitchImgDisplay2 = false;


function loadMain()
{
    // Setttings page
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = SettingsClosed;
    
    // Flyout
    System.Gadget.Flyout.file = "flyout.html";
    
    // Make control bar
    bar.innerHTML = "prev play pause next - reveal";
    makeBar(bar);
    bar_play.style.display="";
    bar_pause.style.display="none";
    
    // Apply current settings
    gCoverWidth = COVERART.style.width;
    gBorder = MAINTABLE.style.borderStyle;
    gDivider = 0; //PN.style.borderTopStyle;
    ApplySettings();
    
    FULLTABLE.style.visibility = "hidden";

    // v 1.3 - Don't connect on startup
    ReportConnectionError();

    // v 2.4 - Get launcher exe from registry
//    GetLauncherFromReg();
    
    // v2.0 - Option to connect on startup
    if( gAutoConnect)
        gTimer = setInterval(ConnectToMC, 5000);
}

function ConnectToMC()
{
    clearTimeout( gTimer);
    
    // Try to connect to MC
    PN.innerText = CONNECTING;
    try
    {
        // See if it is running already
        jrmc = GetObject("", "MediaJukebox Application");
	}
	catch(err)
	{
	    // Try to start it
//        try
//        {
//             jrmc = new ActiveXObject("MediaJukebox Application");
//           
//        }
	    //        catch( err){}

	    // Run externally and wait to connect to prevent focus issues
	    if (gAttempts == 0) 
	        System.Shell.execute(gLauncher, "/Start");

	    gAttempts++;
	    if (gAttempts < 15) 
	    {
	        gTimer = setInterval(ConnectToMC, 2000);
	        return;
	    }
	}
    
    if( jrmc != null)
    {
        // v2.0 - Option to show the JRMC interface
        if( gShowUI)
            jrmc.ShowProgram( 1);
        
        // Try to get desired zone
        try
        {
            if( gZone != 0)
            {
                var zone = jrmc.GetZones().GetZone( gZone - 1);
                if( zone != null)
                    jrmc = zone;
            }
        }
        catch( err){}
        
        // Try to issue startup command
        if( gStartUpCommand != "")
            System.Shell.execute( gLauncher, gStartUpCommand);
        
            
        //start polling timer
        gTimer = setInterval(pollMC, 1000);
    }
    else
    {
        ReportConnectionError();
    }	
}

function ReportConnectionError()
{
    clearTimeout( gTimer);
    jrmc = null;
    gState = -1;
    gCurrentPos = -1;
    COVERARTIMG.src = "gimage:///" + gImageFiles[1] + THUMB_SIZING;
    STATUS.innerText = ERROR1; 
    PN.innerText = ERROR2;
    
    //v2.0
    MAINTABLE.style.visibility = "visible";
    FULLTABLE.style.visibility = "hidden";

    gAttempts = 0;

    PROGRESS.style.width = "100%";
}

// Poll MC for its state every second.
function pollMC()
{
    
    if( jrmc == null)
        return;
        
    try
    {
        var state = jrmc.GetPlayback().State;
        switch( state)
        {
            case 0: // stopped
                {
                    if (gState != state) 
                    {
                        gState = state;
                        ClearInfo();
                        gCurrentPos = -1;
                        STATUS.innerText = STATE_STOP;
                        COVERARTIMG.src = "gimage:///" + gImageFiles[1] + THUMB_SIZING;
                        bar_play.style.display = "";
                        bar_pause.style.display = "none";

                        //v2.0
                        MAINTABLE.style.visibility = "visible";
                        FULLTABLE.style.visibility = "hidden";

                        PROGRESS.style.width = "100%";
                    }
                    break;
                }
            case 1: // paused
            {
                if( gState != state)
                {
                    gState = state;
                    gCurrentPos = -1;
                    STATUS.innerText = STATE_PAUSE;       
                    bar_play.style.display="";
                    bar_pause.style.display="none";
                }
                break;
            }
        case 2: // playing
            {
                // check state
                if (gState != state) {
                    gState = state;
                    bar_play.style.display = "none";
                    bar_pause.style.display = "";
                }

                // check current position
                var pos = jrmc.GetCurPlaylist().Position;
                if (gCurrentPos != pos) {
                    gCurrentPos = pos;
                    pos += 1;
                    UpdateCurrentTrackInfo();
                    gPlayStr = STATE_PLAY + "<br/>" + pos + PLAY_SEPARATOR + jrmc.GetCurPlaylist().GetNumberFiles();
                }

                //time - v2.0 allows custom time string
                var timeremain = jrmc.GetPlayback().Duration - jrmc.GetPlayback().Position;
                var timestr = gTimeStr.replace("{R}", FormatTime(timeremain));
                timestr = timestr.replace("{E}", FormatTime(jrmc.GetPlayback().Position));
                timestr = timestr.replace("{T}", FormatTime(jrmc.GetPlayback().Duration));
                STATUS.innerHTML = gPlayStr + "<br/>" + timestr;

                // v 2.5 - Progress bar
                if (gDivider == 1 && jrmc.GetPlayback().Position > 0)
                    PROGRESS.style.width = (jrmc.GetPlayback().Position / jrmc.GetPlayback().Duration) * 100 + "%";

                break;
            }
        }
    }
    catch( err)
    {
        ReportConnectionError();
    }
}

function FormatTime( time)
{
 	var str = parseInt(time/60) + ":";
 	var sec = time % 60;
 	if( sec < 10)
 	    str += "0" + sec;
 	else
 	    str += sec;
    return str;
}

function UpdateCurrentTrackInfo()
{
    if( jrmc != null)
    {
        var file = jrmc.GetCurPlaylist().GetFile( jrmc.GetCurPlaylist().Position);
        
        // evaluate expression for display string
        PN.innerHTML = file.GetFilledTemplate( gPlayNowExp);
        
        // Set thumbnail
        var thumb = file.GetImageFile( 5);
       // if( gFullImages && file.Get( "Media Type", true) == "Image") // v2.0 - option to size image to full gadget area 
        switch( gImageDisplay)
        {
            case IMAGE_DISPLAY_SMALL:
            {
                MAINTABLE.style.visibility = "visible";
                FULLTABLE.style.visibility = "hidden";
                DIVIDER.style.visibility = (gDivider < 2) ? "visible" : "hidden";
                COVERART.style.width = gCoverWidth;
                
                if( thumb != "")
                    COVERARTIMG.src = "gimage:///" + thumb + THUMB_SIZING;
                else
                    COVERARTIMG.src = "gimage:///" + gImageFiles[2] + THUMB_SIZING;
                    
                break;
            }
            case IMAGE_DISPLAY_FULL:
            case IMAGE_DISPLAY_FULLTEXT:
            {
                var w = FULLTABLE.style.width;
                var h = FULLTABLE.style.height;
                
                MAINTABLE.style.visibility = (gImageDisplay == IMAGE_DISPLAY_FULL) ? "hidden" : "visible";
                FULLTABLE.style.visibility = "visible";
                DIVIDER.style.visibility = (gImageDisplay == IMAGE_DISPLAY_FULL || gDivider == 2) ? "hidden" : "visible";
                if( gImageDisplay == IMAGE_DISPLAY_FULLTEXT)
                    COVERART.style.width = 0;
                
                if( thumb != "")
                    FULLIMAGE.src = "gimage:///" + thumb + "?width=" + w + "&height=" + h;
                else
                    FULLIMAGE.src = "gimage:///" + gImageFiles[2] + "?width=" + w + "&height=" + h;
                    
                break;
            }
            default:
            {
                MAINTABLE.style.visibility = "visible";
                FULLTABLE.style.visibility = "hidden";
                COVERART.style.width = 0;
                break;
            }
        }
            
        // update Flyout if open
        if( System.Gadget.Flyout.show)
            SetFlyout();
    }
}

function ClearInfo()
{
    PN.innerText = "";
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////
// For the options/settings

function SettingsClosed(event)
{
    if (event.closeAction == event.Action.commit)
    {
        ApplySettings();
        if( jrmc != null)
            ConnectToMC();
    }
}

function ApplySettings()
{
    // If the settings aren't saved yet, write defaults, otherwise load them
    var str = "";
    for( var i=0; i < gImageFiles.length; i++)
    {
        str = System.Gadget.Settings.readString("img" + i);
        if( str == "")
            System.Gadget.Settings.writeString("img" + i, gImageFiles[i]);
        else
            gImageFiles[i] = str;
    }
    
    str = System.Gadget.Settings.readString( "Border");
    if( str == "")
        System.Gadget.Settings.write("Border", true);
    else
    {
        MAINTABLE.style.borderStyle = System.Gadget.Settings.read("Border") ? gBorder : "none";
        FULLTABLE.style.borderStyle = System.Gadget.Settings.read("Border") ? gBorder : "none";
    }
        
    str = System.Gadget.Settings.readString( "Divider");
    if (str == "")
        System.Gadget.Settings.write("Divider", "0");
    else 
    {
        //PN.style.borderTopStyle = System.Gadget.Settings.read("Divider") ? gDivider : "none";
        PROGRESS.style.width = "100%";
        try 
        {
            gDivider = parseInt(str);
        }
        catch (err) 
        {
            gDivider = 0;
        }

        if (gDivider == 0 || gDivider == 1)
            DIVIDER.style.visibility = "visible";
        else
            DIVIDER.style.visibility = "hidden";
            
    }
    
    str = System.Gadget.Settings.readString( "PlayNowExp");
    if( str == "")
        System.Gadget.Settings.writeString("PlayNowExp", gPlayNowExp);    
    else
        gPlayNowExp = str;
        
    str = System.Gadget.Settings.readString( "Height");
    if( str == "")
        System.Gadget.Settings.writeString("Height", "130");    
    else
    {
        try
        {
            gHeight = parseInt( str);
            if( gHeight < 130)
                gHeight = 130;
        }
        catch( err)
        {
            gHeight = 130;   
        }
    }
    document.body.style.height = gHeight;
        
    str = System.Gadget.Settings.readString( "Margins");
    if( str == "")
    {
        System.Gadget.Settings.writeString("Margins", "0 0 0 0");    
        FULLTABLE.style.width = 130;
        FULLTABLE.style.height = gHeight;
    }
    else
    {
        var margins = str.split(" ");
        MAINTABLE.style.margin = margins[0] + " " + margins[1] + " " + margins[2] + " " + margins[3]; 
        MAINTABLE.style.width = 130 - margins[1] - margins[3];  
        MAINTABLE.style.height = gHeight - margins[0] - margins[2];
        PN.style.height = gHeight - 70 - margins[0] - margins[2];   
        
        //v2.0
        FULLTABLE.style.margin = margins[0] + " " + margins[1] + " " + margins[2] + " " + margins[3]; 
        FULLTABLE.style.width = 130 - margins[1] - margins[3];  
        FULLTABLE.style.height = gHeight - margins[0] - margins[2]; 
    }
    
    str = System.Gadget.Settings.readString( "Tags");
    if( str == "")
        System.Gadget.Settings.writeString("Tags", gFlyoutTags);    
    else
        gFlyoutTags = str;
        
    str = System.Gadget.Settings.readString( "Zone");
    if( str == "")
        System.Gadget.Settings.writeString("Zone", "0");    
    else
    {
        try
        {
            gZone = parseInt( str);
        }
        catch( err)
        {
            gZone = 1;   
        }
    }
        
    str = System.Gadget.Settings.readString( "StartCommand");
    if( str == "")
        System.Gadget.Settings.writeString("StartCommand", gStartUpCommand);    
    else
        gStartUpCommand = str;

    str = System.Gadget.Settings.readString( "ImageDisplay");
    if( str == "")
        System.Gadget.Settings.writeString("ImageDisplay", "0");    
    else
    {
        try
        {
            gImageDisplay = parseInt( str);
            if( gImageDisplay < 0 || gImageDisplay > IMAGE_DISPLAY_NONE)
                gImageDisplay = 0;
                
            //v2.3 - option to switch image display on hover
            if (gImageDisplay == IMAGE_DISPLAY_SWITCH) 
            {
                gSwitchImgDisplay = true;
                gSwitchImgDisplay2 = false;
                gImageDisplay = IMAGE_DISPLAY_FULL;
            }
            else if (gImageDisplay == IMAGE_DISPLAY_SWITCH2) 
            {
                gSwitchImgDisplay2 = true;
                gSwitchImgDisplay = false;
                gImageDisplay = IMAGE_DISPLAY_SMALL;
            }
            else 
            {
                gSwitchImgDisplay = false;
                gSwitchImgDisplay2 = false;
            }   
        }
        catch( err)
        {
            gImageDisplay = IMAGE_DISPLAY_SMALL;   
        }
    }
    
    str = System.Gadget.Settings.readString( "TimeString");
    if( str == "")
        System.Gadget.Settings.writeString("TimeString", gTimeStr);    
    else
        gTimeStr = str;
        
    str = System.Gadget.Settings.readString( "ShowUI");
    if( str == "")
        System.Gadget.Settings.write("ShowUI", gShowUI);
    else
        gShowUI = (str == "True");
        
    str = System.Gadget.Settings.readString( "AutoConnect");
    if( str == "")
        System.Gadget.Settings.write("AutoConnect", gAutoConnect);
    else
        gAutoConnect = (str == "True");

    // v2.5 - Launcher and colors
    str = System.Gadget.Settings.readString("Launcher");
    if (str == "")
        System.Gadget.Settings.write("Launcher", gLauncher);
    else
        gLauncher = str;

    str = System.Gadget.Settings.readString("TextColor");
    if (str == "")
        System.Gadget.Settings.write("TextColor", "#FFFFFF");
    else
        MAINTABLE.style.color = str;

    str = System.Gadget.Settings.readString("ProgColor");
    if (str == "")
        System.Gadget.Settings.write("ProgColor", "#FFFFFF");
    else
        PROGRESS.style.backgroundColor = str;

    str = System.Gadget.Settings.readString("ProgBackColor");
    if (str == "")
        System.Gadget.Settings.write("ProgBackColor", "#808080");
    else
        DIVIDER.style.backgroundColor = str;
   
    // Set up background
    BKGD.src = gImageFiles[0];
    BKGD.style.width = 130;
    BKGD.style.height = gHeight;
    
    // Make sure Playing Now text is regenerated
    gCurrentPos = -1;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////
// For flyout
function ShowFlyout() 
{
    try
    {
        if( System.Gadget.Flyout.show)
        {
            System.Gadget.Flyout.show = false;
        }
        else
        {
            if( jrmc == null)
                return;
           
            System.Gadget.Flyout.onShow = function() { SetFlyout(); }
            System.Gadget.Flyout.show = true;
        }
    }
    catch( err)
    {
        //PN.innerText = err.Description;
    }
}

function SetFlyout()
{
    var file = jrmc.GetCurPlaylist().GetFile( jrmc.GetCurPlaylist().Position);
    System.Gadget.Flyout.document.parentWindow.Init( file, gFlyoutTags, jrmc.GetPlaylists());
    System.Gadget.Flyout.document.parentWindow.Fill();
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////
// The routines below were mostly "borrowed" from the SlideShow Gadget for a consistent control bar.

////////////////////////////////////////////////////////////////////////////////
//
// creates navigation bar
//
////////////////////////////////////////////////////////////////////////////////
function makeBar(controlsString)
{
    var controlsArray=controlsString.innerText.split(" ");
    var controlName;
    var newImageToAdd;
    var newLabelToAdd;
    var labelsForRollovers = "";
    var imageRollovers = "<div id='backBar'></div><div id='topBar'>";
    var i=0;
    while(controlName=controlsArray[i++])
    {
        var controlNameAction = controlName;
        if (controlName=="-")
        {
            newImageToAdd = "";
        }
        else
        {
            newImageToAdd = "<a id='link_" + controlNameAction + "' href='javascript:void(0);' onClick='this.blur();'>"
                + "<img border=0 id='bar_" + controlNameAction + "' hspace='3' src='"+BAR_IMAGES_PATH+controlName+"_rest.png' "
                + "onMouseOver='src=\""+BAR_IMAGES_PATH + controlName + "_hov.png\"' onMouseOut='src=\""+BAR_IMAGES_PATH + controlName + "_rest.png\"' "
                + "onMouseDown='src=\""+BAR_IMAGES_PATH + controlName + "_down.png\"' onMouseUp='src=\""+BAR_IMAGES_PATH + controlName + "_hov.png\";"
                + "onAction(\"" + controlNameAction + "\");' \>"
                + "</a>";
            newLabelToAdd = "<label for='link_"+controlName+"'>"+controlName+"</label>";
        }
        imageRollovers += newImageToAdd;
        labelsForRollovers += newLabelToAdd;
    }
    imageRollovers += "</div>";
    controlsString.innerHTML=imageRollovers;
}

////////////////////////////////////////////////////////////////////////////////
//
// show navigation bar with fade-in
//
////////////////////////////////////////////////////////////////////////////////
function showBar()
{
    if(event.fromElement)
    {
        return;
    }
    clearTimeout(bar.timer);
    up();
}
////////////////////////////////////////////////////////////////////////////////
//
// hide navigation bar with fade-out
//
////////////////////////////////////////////////////////////////////////////////
function hideBar()
{
    if(event.toElement)
    {
        return;
    }
    clearTimeout(bar.timer);
    down();
    bar.blur();
    
} 
 
function up()
{
    with(bar.filters("alpha"))
    {
        if((opacity+=15)<75)
        {
            bar.timer=setTimeout(up,25);
        }
        else
        {
            opacity=75;
        }
    }
}
  
function down()
{
    with(bar.filters("alpha"))
    {
        if((opacity-=15)>0)
        {
            bar.timer=setTimeout(down,25);
        }
        else
        {
            opacity=0;
        }
    }
}

// Respond to control bar button clicks
function onAction(action)
{              
    if( jrmc == null)
    {
        if (action == "reveal" && event.button == 1)
        {
            // Try to reconnect
            PN.innerText = CONNECTING;
            STATUS.innerText = "";
            gTimer = setInterval(ConnectToMC, 2000);
            return true;
         }
         else
            return false;
    }
        
    if( event.button == 1)
    {
        switch(action)
        {
            case "prev":
                jrmc.GetPlayback().Previous();
                break;
            case "play":
                if( jrmc.GetPlayback().State == 1)  // is it paused?  then "unpause"
                    jrmc.GetPlayback().Pause();
                else
                    jrmc.GetPlayback().Play();
                break;
            case "pause":
                jrmc.GetPlayback().Pause();
                break; 
            case "next":
                jrmc.GetPlayback().Next();
                break;
            case "reveal":
                jrmc.ShowProgram( 1);
                break;
       }
    }
    else if( event.button == 4 && (action == "pause" || action == "play") ) // middle-click on pause or play will stop
    {
        jrmc.GetPlayback().Stop();
    }
    else if( event.button == 4 && action == "reveal") // middle-click on "reveal" will close connection and shut down MC
    {
       // if( jrmc != null)
	   //     System.Shell.execute( "MC" + jrmc.GetVersion().Major + ".exe", "/Close");
	    ReportConnectionError();
    }
    
}

function switchDisplayIn()
{
    if(event.fromElement == null) 
    {
        if (gSwitchImgDisplay) 
        {
            gImageDisplay = IMAGE_DISPLAY_SMALL;
            UpdateCurrentTrackInfo();
        }
        else if (gSwitchImgDisplay2) 
        {
            gImageDisplay = IMAGE_DISPLAY_FULL;
            UpdateCurrentTrackInfo();
        }
    }
}

function switchDisplayOut()
{
    if (event.toElement == null) 
    {
        if (gSwitchImgDisplay) 
        {      
            gImageDisplay = IMAGE_DISPLAY_FULL;
            UpdateCurrentTrackInfo();
        }
        else if (gSwitchImgDisplay2) 
        {
            gImageDisplay = IMAGE_DISPLAY_SMALL;
            UpdateCurrentTrackInfo();
        }
    }
}

function GetLauncherFromReg() 
{
    try 
    {
        var shellobj = new ActiveXObject("WScript.Shell");
        var sInstallKey = shellobj.RegRead(REG_INSTALL);
        gLauncher = shellobj.RegRead(REG_INSTALL + "\\" + sInstallKey + "\\Launcher Name");
    }
    catch (Error) { }
}